package com.zd.laboratory.mapper;

import com.zd.laboratory.domain.LabAbnormal;
import com.zd.laboratory.domain.vo.LabAbnormalVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 异常设备Mapper接口
 *
 * @author zd
 * @date 2021-09-07
 */
public interface LabAbnormalMapper {
    /**
     * 查询异常设备
     *
     * @param id 异常设备主键
     * @return 异常设备
     */
    public LabAbnormal selectLabAbnormalById(Long id);

    /**
     * 查询异常设备列表
     *
     * @param labAbnormal 异常设备
     * @return 异常设备集合
     */
    public List<LabAbnormalVO> selectLabAbnormalList(LabAbnormalVO labAbnormal);

    /**
     * 查询设备列表
     *
     * @param labAbnormal 设备
     * @return 设备集合
     */
    public List<LabAbnormalVO> getEquipmentList(LabAbnormalVO labAbnormal);

    /**
     * 查询设备信息
     *
     * @param labAbnormal 设备
     * @return 设备集合
     */
    public LabAbnormalVO getEquipmentVo(LabAbnormalVO labAbnormal);

    /**
     * 新增异常设备
     *
     * @param labAbnormal 异常设备
     * @return 结果
     */
    public int insertLabAbnormal(LabAbnormal labAbnormal);

    /**
     * 修改异常设备
     *
     * @param labAbnormal 异常设备
     * @return 结果
     */
    public int updateLabAbnormal(LabAbnormal labAbnormal);

    /**
     * 删除异常设备
     *
     * @param id 异常设备主键
     * @return 结果
     */
    public int deleteLabAbnormalById(Long id);

    /**
     * 批量删除异常设备
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteLabAbnormalByIds(Long[] ids);


    /**
     * 根据设备id删除异常记录
     *
     * @param labAbnormal 异常设备对象
     * @return 结果
     */
    public int delEquipment(LabAbnormal labAbnormal);

    /**
     * 获取设备统计异常信息
     *
     * @param labAbnormal 设备对象
     * @return 异常设备
     */
    public LabAbnormalVO getAbnormalCount(LabAbnormal labAbnormal);

    List<Map<String, Object>> queryFailures(Map<String, Object> params);

    int insertBatch(@Param("entities") List<LabAbnormal> abnormals);
}
